Loading...
Searching...
No Matches
casacore::TSMIdColumn Class Reference
tables package (libcasa_tables) » DataMan_module » DataMan_module_internal_classes

More...

`#include <TSMIdColumn.h>`

## Public Member Functions

| TSMIdColumn (const TSMColumn &column)
| Create an id column from the given column.
virtual | ~TSMIdColumn ()
| Frees up the storage.
| TSMIdColumn (const TSMIdColumn &)=delete
| Forbid copy constructor.
TSMIdColumn & | operator= (const TSMIdColumn &)=delete
| Forbid assignment.
virtual void | getBool (rownr_t rownr, Bool *dataPtr)
| Get a scalar value in the given row.
virtual void | getInt (rownr_t rownr, Int *dataPtr)
virtual void | getuInt (rownr_t rownr, uInt *dataPtr)
virtual void | getInt64 (rownr_t rownr, Int64 *dataPtr)
virtual void | getfloat (rownr_t rownr, float *dataPtr)
virtual void | getdouble (rownr_t rownr, double *dataPtr)
virtual void | getComplex (rownr_t rownr, Complex *dataPtr)
virtual void | getDComplex (rownr_t rownr, DComplex *dataPtr)
virtual void | getString (rownr_t rownr, String *dataPtr)
virtual void | putBool (rownr_t rownr, const Bool *dataPtr)
| Put a scalar value in the given row.
virtual void | putInt (rownr_t rownr, const Int *dataPtr)
virtual void | putuInt (rownr_t rownr, const uInt *dataPtr)
virtual void | putInt64 (rownr_t rownr, const Int64 *dataPtr)
virtual void | putfloat (rownr_t rownr, const float *dataPtr)
virtual void | putdouble (rownr_t rownr, const double *dataPtr)
virtual void | putComplex (rownr_t rownr, const Complex *dataPtr)
virtual void | putDComplex (rownr_t rownr, const DComplex *dataPtr)
virtual void | putString (rownr_t rownr, const String *dataPtr)
Public Member Functions inherited from casacore::TSMColumn
| TSMColumn (TiledStMan *stman, int dataType, const String &columnName)
| Create a column of the given type.
virtual | ~TSMColumn ()
| Frees up the storage.
TSMColumn & | operator= (const TSMColumn &)=delete
| Forbid assignment.
const String & | columnName () const
| Get the name of the column.
virtual int | dataType () const
| Return the data type of the column.
void | setShapeColumn (const IPosition &shape)
| Set the fixed shape of the column.
const IPosition & | shapeColumn () const
| Get the fixed shape of the column.
TSMDataColumn * | makeDataColumn ()
| Make a TSM data column object.
TSMCoordColumn * | makeCoordColumn (uInt axesNumber)
| Make a TSM coordinate column object.
TSMIdColumn * | makeIdColumn ()
| Make a TSM id column object.
TSMColumn * | unlink ()
| Unlink the underlying column.
Public Member Functions inherited from casacore::StManColumnBase
| StManColumnBase (int dataType)
| Default constructor.
| ~StManColumnBase ()
| StManColumnBase (const StManColumnBase &)=delete
| The object cannot be copied.
StManColumnBase & | operator= (const StManColumnBase &)=delete
| The object cannot be assigned to.
DataType | dtype () const
Int | elemSize () const
| Return the size of an element of the column's data type.
Public Member Functions inherited from casacore::DataManagerColumn
| DataManagerColumn ()
| Create a column.
virtual | ~DataManagerColumn ()
| Frees up the storage.
| DataManagerColumn (const DataManagerColumn &)=delete
| The copy constructor cannot be used for this base class.
DataManagerColumn & | operator= (const DataManagerColumn &)=delete
| Assignment cannot be used for this base class.
void | setIsFixedShape (Bool isFixedShape)
| Set the isFixedShape flag.
Bool | isFixedShape () const
| Is this a fixed shape column?
virtual String | dataTypeId () const
| Get the data type id of the column for dataType==TpOther.
virtual Bool | isWritable () const
| Test if data can be put into this column.
virtual void | setMaxLength (uInt maxLength)
| Set the maximum length of the value (can be used for strings).
void | setFixedShapeColumn (const IPosition &shape)
| Set the shape of all (fixed-shaped) arrays in the column.
virtual void | setShape (rownr_t rownr, const IPosition &shape)
| Set the shape of an (variable-shaped) array in the given row.
virtual void | setShapeTiled (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of an (variable-shaped) array in the given row.
virtual Bool | isShapeDefined (rownr_t rownr)
| Is the value shape defined in the given row?
virtual uInt | ndim (rownr_t rownr)
| Get the dimensionality of the item in the given row.
virtual IPosition | shape (rownr_t rownr)
| Get the shape of the item in the given row.
virtual IPosition | tileShape (rownr_t rownr)
| Get the tile shape of the item in the given row.
virtual Bool | canChangeShape () const
| Can the data manager handle chaging the shape of an existing array?
ColumnCache & | columnCache ()
| Get access to the ColumnCache object.
const ColumnCache * | columnCachePtr () const
void | get (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
void | get (rownr_t rownr, uChar *dataPtr)
void | get (rownr_t rownr, Short *dataPtr)
void | get (rownr_t rownr, uShort *dataPtr)
void | get (rownr_t rownr, Int *dataPtr)
void | get (rownr_t rownr, uInt *dataPtr)
void | get (rownr_t rownr, Int64 *dataPtr)
void | get (rownr_t rownr, float *dataPtr)
void | get (rownr_t rownr, double *dataPtr)
void | get (rownr_t rownr, Complex *dataPtr)
void | get (rownr_t rownr, DComplex *dataPtr)
void | get (rownr_t rownr, String *dataPtr)
void | get (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
void | put (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
void | put (rownr_t rownr, const uChar *dataPtr)
void | put (rownr_t rownr, const Short *dataPtr)
void | put (rownr_t rownr, const uShort *dataPtr)
void | put (rownr_t rownr, const Int *dataPtr)
void | put (rownr_t rownr, const uInt *dataPtr)
void | put (rownr_t rownr, const Int64 *dataPtr)
void | put (rownr_t rownr, const float *dataPtr)
void | put (rownr_t rownr, const double *dataPtr)
void | put (rownr_t rownr, const Complex *dataPtr)
void | put (rownr_t rownr, const DComplex *dataPtr)
void | put (rownr_t rownr, const String *dataPtr)
void | put (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
virtual void | getScalarColumnV (ArrayBase &dataPtr)
| Get all scalar values in the column.
virtual void | putScalarColumnV (const ArrayBase &dataPtr)
| Put all scalar values in the column.
virtual void | getScalarColumnCellsV (const RefRows &rownrs, ArrayBase &dataPtr)
| Get some scalar values in the column.
virtual void | putScalarColumnCellsV (const RefRows &rownrs, const ArrayBase &dataPtr)
| Put some scalar values in the column.
virtual void | getArrayV (rownr_t rownr, ArrayBase &dataPtr)
| Get the array value in the given row.
virtual void | putArrayV (rownr_t rownr, const ArrayBase &data)
| Put the array value into the given row.
virtual void | getArrayColumnV (ArrayBase &data)
| Get all array values in the column.
virtual void | putArrayColumnV (const ArrayBase &data)
| Put all array values in the column.
virtual void | getArrayColumnCellsV (const RefRows &rownrs, ArrayBase &data)
| Get some array values in the column.
virtual void | putArrayColumnCellsV (const RefRows &rownrs, const ArrayBase &data)
| Put some array values in the column.
virtual void | getSliceV (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
| Get a section of the array in the given row.
virtual void | putSliceV (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
| Put into a section of the array in the given row.
virtual void | getColumnSliceV (const Slicer &slicer, ArrayBase &data)
| Get a section of all arrays in the column.
virtual void | putColumnSliceV (const Slicer &slicer, const ArrayBase &data)
| Put into a section of all arrays in the column.
virtual void | getColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
| Get a section of some arrays in the column.
virtual void | putColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)
| Put into a section of some arrays in the column.
void | throwGet () const
| Throw an "invalid operation" exception for the default implementation of get.
void | throwPut () const
| Throw an "invalid operation" exception for the default implementation of put.
void | setColumnName (const String &colName)
| Set the column name.
const String & | columnName () const
| Get rhe column name.

## Additional Inherited Members

Static Public Member Functions inherited from casacore::StManColumnBase
static Bool | isNativeDataType (int dtype)
| Test if the given data type is supported by storage managers.
Protected Member Functions inherited from casacore::TSMColumn
| TSMColumn (const TSMColumn &that)
| The copy constructor can only be used to copy a derived class.
Protected Member Functions inherited from casacore::DataManagerColumn
virtual void | getuChar (rownr_t rownr, uChar *dataPtr)
virtual void | getShort (rownr_t rownr, Short *dataPtr)
virtual void | getuShort (rownr_t rownr, uShort *dataPtr)
virtual void | getOther (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
virtual void | putuChar (rownr_t rownr, const uChar *dataPtr)
virtual void | putShort (rownr_t rownr, const Short *dataPtr)
virtual void | putuShort (rownr_t rownr, const uShort *dataPtr)
virtual void | putOther (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | getScalarColumnBase (ArrayBase &dataPtr)
| The default implementations of get and put functions.
void | putScalarColumnBase (const ArrayBase &dataPtr)
void | getScalarColumnCellsBase (const RefRows &rownrs, ArrayBase &dataPtr)
void | putScalarColumnCellsBase (const RefRows &rownrs, const ArrayBase &dataPtr)
void | getArrayColumnBase (ArrayBase &data)
void | putArrayColumnBase (const ArrayBase &data)
void | getArrayColumnCellsBase (const RefRows &rownrs, ArrayBase &data)
void | putArrayColumnCellsBase (const RefRows &rownrs, const ArrayBase &data)
void | getSliceBase (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
void | putSliceBase (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceBase (const Slicer &slicer, ArrayBase &data)
void | putColumnSliceBase (const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
void | putColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)
Protected Attributes inherited from casacore::TSMColumn
TiledStMan * | stmanPtr_p
| The storage manager.
int | dtype_p
| The data type of the data (as defined in DataType.h).
String | name_p
| The name of the column.
IPosition | columnShape_p
| The fixed shape of the column.
TSMColumn * | colPtr_p
| The specialized column object (i.e.

## Detailed Description

An id column in Tiled Storage Manager.

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- TSMColumn
- TSMCube
- Record

### Etymology

TSMIdColumn handles an id column for a Tiled Storage Manager.

### Synopsis

TSMIdColumn is used by TiledStMan to handle the access to a table column containing an id value of a tiled hypercube. Explicitly putting an id value is not possible. The only way to define the value is by specifying it when adding a hypercube in TiledDataStMan.

The id values are held in a TSMCube object. The row number determines which TSMCube object has to be accessed.

The creation of a TSMIdColumn object is done by a TSMColumn object. This process is described in more detail in the class TSMColumn.

### Motivation

Handling coordinate columns in the Tiled Storage Manager is different from other columns.

Definition at line 88 of file TSMIdColumn.h.

## Constructor & Destructor Documentation

## TSMIdColumn() [1/2]

casacore::TSMIdColumn::TSMIdColumn | ( | const TSMColumn & | column | ) |

Create an id column from the given column.

References casacore::TSMColumn::TSMColumn().

Referenced by operator=(), and TSMIdColumn().

## ~TSMIdColumn()

virtual casacore::TSMIdColumn::~TSMIdColumn | ( |  | ) |

virtual

Frees up the storage.

## TSMIdColumn() [2/2]

casacore::TSMIdColumn::TSMIdColumn | ( | const TSMIdColumn & |  | ) |

delete

Forbid copy constructor.

References TSMIdColumn().

## Member Function Documentation

## getBool()

virtual void casacore::TSMIdColumn::getBool | ( | rownr_t | rownr,
|  | Bool * | dataPtr )

virtual

Get a scalar value in the given row.

The buffer pointed to by dataPtr has to have the correct length (which is guaranteed by the ScalarColumn get function).

Reimplemented from casacore::DataManagerColumn.

## getComplex()

virtual void casacore::TSMIdColumn::getComplex | ( | rownr_t | rownr,
|  | Complex * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getDComplex()

virtual void casacore::TSMIdColumn::getDComplex | ( | rownr_t | rownr,
|  | DComplex * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getdouble()

virtual void casacore::TSMIdColumn::getdouble | ( | rownr_t | rownr,
|  | double * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getfloat()

virtual void casacore::TSMIdColumn::getfloat | ( | rownr_t | rownr,
|  | float * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getInt()

virtual void casacore::TSMIdColumn::getInt | ( | rownr_t | rownr,
|  | Int * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getInt64()

virtual void casacore::TSMIdColumn::getInt64 | ( | rownr_t | rownr,
|  | Int64 * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getString()

virtual void casacore::TSMIdColumn::getString | ( | rownr_t | rownr,
|  | String * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getuInt()

virtual void casacore::TSMIdColumn::getuInt | ( | rownr_t | rownr,
|  | uInt * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## operator=()

TSMIdColumn & casacore::TSMIdColumn::operator= | ( | const TSMIdColumn & |  | ) |

delete

Forbid assignment.

References TSMIdColumn().

## putBool()

virtual void casacore::TSMIdColumn::putBool | ( | rownr_t | rownr,
|  | const Bool * | dataPtr )

virtual

Put a scalar value in the given row.

The buffer pointed to by dataPtr has to have the correct length (which is guaranteed by the ScalarColumn get function). The value to be put must match the value which has already been inserted by the TiledStMan::addHypercube function. The put function is only there to be fully orthogonal.

Reimplemented from casacore::DataManagerColumn.

## putComplex()

virtual void casacore::TSMIdColumn::putComplex | ( | rownr_t | rownr,
|  | const Complex * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putDComplex()

virtual void casacore::TSMIdColumn::putDComplex | ( | rownr_t | rownr,
|  | const DComplex * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putdouble()

virtual void casacore::TSMIdColumn::putdouble | ( | rownr_t | rownr,
|  | const double * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putfloat()

virtual void casacore::TSMIdColumn::putfloat | ( | rownr_t | rownr,
|  | const float * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putInt()

virtual void casacore::TSMIdColumn::putInt | ( | rownr_t | rownr,
|  | const Int * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putInt64()

virtual void casacore::TSMIdColumn::putInt64 | ( | rownr_t | rownr,
|  | const Int64 * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putString()

virtual void casacore::TSMIdColumn::putString | ( | rownr_t | rownr,
|  | const String * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putuInt()

virtual void casacore::TSMIdColumn::putuInt | ( | rownr_t | rownr,
|  | const uInt * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

The documentation for this class was generated from the following file:

- tables/DataMan/TSMIdColumn.h